- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# junos_scp – Transfer files from or to remote devices running Junos

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module transfers files via SCP from or to remote devices running Junos.

## Requirements

The below requirements are needed on the host that executes this module.

- junos-eznc
- ncclient (>=v0.5.2)

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
dest - | Default: "." | The `dest` argument specifies the path in which to receive the files.
provider dictionary |  | Deprecated Starting with Ansible 2.5 we recommend using `connection: network_cli` or `connection: netconf`. For more information please see the Junos OS Platform Options guide. A dict object containing connection details.
| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device. The port value will default to the well known SSH port of 22 (for `transport=cli`) or port 830 (for `transport=netconf`) device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
recursive boolean | Choices: no ← yes | The `recursive` argument enables recursive transfer of files and directories.
remote_src boolean | Choices: no ← yes | The `remote_src` argument enables the download of files (scp get) from the remote device. The default behavior is to upload files (scp put) to the remote device.
src - / required |  | The `src` argument takes a single path, or a list of paths to be transferred. The argument `recursive` must be `true` to transfer directories.

## Notes

Note

- This module requires the netconf system service be enabled on the remote device being managed.
- Tested against vMX JUNOS version 17.3R1.10.
- Works with `local` connections only.
- For information on using CLI and netconf see the Junos OS Platform Options guide
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Juniper network devices see https://www.ansible.com/ansible-juniper.

## Examples

    # the required set of connection arguments have been purposely left off
    # the examples for brevity
    - name: upload local file to home directory on remote device
      junos_scp:
        src: test.tgz

    - name: upload local file to tmp directory on remote device
      junos_scp:
        src: test.tgz
        dest: /tmp/

    - name: download file from remote device
      junos_scp:
        src: test.tgz
        remote_src: true

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
changed boolean | always | always true

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Christian Giese (@GIC-de)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.